///extract single frame from motionjpeg stream from
///RICOH THETA Z1 livePreview
import 'dart:async';
import 'dart:convert';
import 'dart:io';

main(List<String> args) async {
  File fileHandle = File('test_frame.jpg');
  Uri url = Uri.parse('http://192.168.1.1/osc/commands/execute');
  var client = HttpClient();
  Map<String, String> bodyMap = {"name": "camera.getLivePreview"};

  var request = await client.postUrl(url)
    ..headers.contentType = ContentType("application", "json", charset: "utf-8")
    ..write(jsonEncode(bodyMap));

  var response = await request.close();
  StreamSubscription? videoStream;
  var startIndex = -1;
  var endIndex = -1;
  List<int> buf = [];
  videoStream = response.listen(
    (List<int> data) {
      buf.addAll(data);
      for (var i = 0; i < data.length - 1; i++) {
        if (data[i] == 0xFF && data[i + 1] == 0xD8) {
          startIndex = i;
        }
        if (data[i] == 0xff && data[i + 1] == 0xd9) {
          endIndex = buf.length;
        }
      }
      if (startIndex != -1 && endIndex != -1) {
        print('saving frame');
        fileHandle.writeAsBytes(buf.sublist(startIndex, endIndex));
        print('finished saving frames');
        if (videoStream != null) {
          videoStream.cancel();
          client.close();
        }
      }
    },
  );
}
